Package com.emc.d2fs.interfaces

# Interface IContentService

All Superinterfaces:
  `ID2fsService`

public interface IContentService extends ID2fsService
Doclist content, filtering and facet services

- ## Method Summary

  Modifier and Type
  Method
  Description
  `AllowedFiles`
  `getAllowedFiles(Context context)`
  Return the allow list or deny list of allowed files and which list is being used
  `DocItems`
  `getContent(Context context, String id, String contentTypeName, String viewMode, String checkChildren)`
  Get document children as list
  `List<Option>`
  `getDoclistFilterOptions(Context context)`
  Get property names for Doclist filter combo box
  `DocItems`
  `getDQLContent(Context context, String id, String query, String viewMode)`
  Get content, using a query, id can serve to either replace $value(filter) or if representing a Repository object, it can serve to resolve any $value in the query
  `DocItems`
  `getDQLContentFromConfigName(Context context, String id, String configName, String viewMode)`
  Get content, using a specific widget config name, id can serve to either replace $value(filter) or if representing a Repository object, it can serve to resolve any $value in the query
  `DocItems`
  `getDynamicContent(Context context, String id, String contentTypeName, List<Attribute> parameters)`
  Get content, using a dynamic content, id can serve to parent content id
  `DocItems`
  `getFacetContent(Context context, String id, String contentTypeName, String facetName, String facetValue, String resetFacetName, String viewMode, String checkChildren, String facetCountInfo)`
  Get document children of the facet item as list
  `DocItems`
  `getFilteredContent(Context context, String id, String contentTypeName, String viewMode, String checkChildren, String filter, String filterPropName, String locateId)`
  Get children as list with filter Like getContent except that only the subset of items that match the supplied object_name filter are returned.
  `List<DocItems>`
  `getMultiContent(List<Context> contexts, String contentTypeName, String viewMode)`
  Get document lists over multiple docbase by type name
  `SearchResults`
  `getSearchContent(Context context, String id, String contentTypeName, String facetName, String facetValue, String resetFacetName, String viewMode, String checkChildren, String facetCountInfo)`
  Get combined Search and Facets content as a single item/structure
  `DocItems`
  `getTasksSearchContent(Context context, String configName, String id, String searchTerm)`
  Create a search using dql to custom search parameters

  ### Methods inherited from interface com.emc.d2fs.interfaces.ID2fsService

  `isRemote, setRemote`

- ## Method Details

  - ### getContent

    DocItems getContent(Context context, String id, String contentTypeName, String viewMode, String checkChildren) throws Exception
    Get document children as list
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of parent document id
      `contentTypeName` - String value of root content type name (repository, folder, virtual document, ...); See `D2fsConstants` "content type names".
      `viewMode` - String value of view mode ("details" or "thumbnails")
      `checkChildren` - String value of targeted children logic control (folder, folderOrVd, folderOrDocument or null)
    Returns:
      `DocItems` object
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### getMultiContent

    List<DocItems> getMultiContent(List<Context> contexts, String contentTypeName, String viewMode) throws Exception
    Get document lists over multiple docbase by type name
    Parameters:
      `contexts` - `Context` list of object containing informations about client/session
      `contentTypeName` - String value of root content type name (repository, folder, virtual document, ...); See `D2fsConstants` "content type names".
      `viewMode` - String value of view mode ("details" or "thumbnails")
    Returns:
      `DocItems` list
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### getDoclistFilterOptions

    List<Option> getDoclistFilterOptions(Context context) throws Exception
    Get property names for Doclist filter combo box
    Parameters:
      `context` - `Context` object containing informations about client/session
    Returns:
      `String` list
    Throws:
      `Exception`
    Since:
      4.1

  - ### getAllowedFiles

    AllowedFiles getAllowedFiles(Context context) throws Exception
    Return the allow list or deny list of allowed files and which list is being used
    Parameters:
      `context` -
    Returns:
    Throws:
      `Exception`

  - ### getFilteredContent

    DocItems getFilteredContent(Context context, String id, String contentTypeName, String viewMode, String checkChildren, String filter, String filterPropName, String locateId) throws Exception
    Get children as list with filter Like getContent except that only the subset of items that match the supplied object_name filter are returned. For example, if filter == "A", then the clause "AND object_name LIKE 'A%'" is added to the DQL query string used to obtain the result set. Note that the underlying ID2Content.getFilteredContent method can truncate the result set if it too large. In this case, the returned DocItems.count value will be set and can be used by the caller to determine if truncation of the result set occurred. For example, the getFilteredContent method could simply set DocItems.count = -1 if the result set was truncated. Alternatively, DocItems.count could be set to the number of items that would have been returned without the filter. In this case, DocItems.getItems().size() < count would be true if the result set was truncated.
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of parent document id
      `contentTypeName` - String value of root content type name (repository, folder, virtual document, ...); See `D2fsConstants` "content type names".
      `viewMode` - String value of view mode ("details" or "thumbnails")
      `checkChildren` - String value of targeted children logic control (folder, folderOrVd, folderOrDocument or null)
      `filter` - String value used to filter result set
      `filterPropName` - String value of attribute name used to filter result set
      `locateId` - String value used to include specific item in result set
    Returns:
      `DocItems` object
    Throws:
      `Exception`
    Since:
      4.1.0

  - ### getFacetContent

    DocItems getFacetContent(Context context, String id, String contentTypeName, String facetName, String facetValue, String resetFacetName, String viewMode, String checkChildren, String facetCountInfo) throws Exception
    Get document children of the facet item as list
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of parent document id
      `contentTypeName` - String value of root content type name (repository, folder, virtual document, ...); See `D2fsConstants` "content type names".
      `viewMode` - String value of view mode ("details" or "thumbnails")
      `checkChildren` - String value of targeted children logic control (folder, folderOrVd, folderOrDocument or null)
      `facetName` - String value of attribute name used as facet
      `facetValue` - String value of facet item
      `resetFacetName` - String value of the facet that the selection needs to be cleared
      `facetCountInfo` - String specifying details about how many values of each facet to return
    Returns:
      `DocItems` object
    Throws:
      `Exception`
    Since:
      4.1.0

  - ### getDQLContent

    DocItems getDQLContent(Context context, String id, String query, String viewMode) throws Exception
    Get content, using a query, id can serve to either replace $value(filter) or if representing a Repository object, it can serve to resolve any $value in the query
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of document id
      `query` - String value of query that execution will serve to generate the content list, if null context must be set with the widget config name so we can gather the correct value
      `viewMode` - String value of view mode ("details" or "thumbnails")
    Returns:
      `DocItems` object
    Throws:
      `Exception`
    Since:
      4.2.0

  - ### getDQLContentFromConfigName

    DocItems getDQLContentFromConfigName(Context context, String id, String configName, String viewMode) throws Exception
    Get content, using a specific widget config name, id can serve to either replace $value(filter) or if representing a Repository object, it can serve to resolve any $value in the query
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of document id
      `configName` - String value of configName that execution will serve to generate the content list (it is used to retrieve the correct dql value) If null, context widget name will be used.
      `viewMode` - String value of view mode ("details" or "thumbnails")
    Returns:
      `DocItems` object
    Throws:
      `Exception`
    Since:
      4.6.1

  - ### getDynamicContent

    DocItems getDynamicContent(Context context, String id, String contentTypeName, List<Attribute> parameters) throws Exception
    Get content, using a dynamic content, id can serve to parent content id
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of content id (can be passed into the list of attributes directly)
      `contentTypeName` - String value of root content type name (repository, folder, virtual document, ...); See `D2fsConstants` "content type names".
      `parameters` - List of attribute value that execution will serve to generate the content list (viewMode, checkChildren, filter, filterPropName, locateId)
    Returns:
      `DocItems` object
    Throws:
      `Exception`
    Since:
      4.2.1

  - ### getSearchContent

    SearchResults getSearchContent(Context context, String id, String contentTypeName, String facetName, String facetValue, String resetFacetName, String viewMode, String checkChildren, String facetCountInfo) throws Exception
    Get combined Search and Facets content as a single item/structure
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of parent document id
      `contentTypeName` - String value of root content type name (repository, folder, virtual document, ...); See `D2fsConstants` "content type names".
      `viewMode` - String value of view mode ("details" or "thumbnails")
      `checkChildren` - String value of targeted children logic control (folder, folderOrVd, folderOrDocument or null)
      `facetName` - String value of attribute name used as facet
      `facetValue` - String value of facet item
      `resetFacetName` - String value of the facet that the selection needs to be cleared
      `facetCountInfo` - String specifying details about how many values of each facet to return
    Returns:
      `SearchResults` object
    Throws:
      `Exception`
    Since:
      4.7.0

  - ### getTasksSearchContent

    DocItems getTasksSearchContent(Context context, String configName, String id, String searchTerm) throws Exception
    Create a search using dql to custom search parameters
    Parameters:
      `context` - `Context` object containing informations about client/session
      `searchTerm` - String value of search term.
    Returns:
      true if process performs without error
    Throws:
      `Exception`
    Since:
      4.8.0